library ieee;
use ieee.std_logic_1164.all;

library ADC_components;
use ADC_components.components.all;

entity TOP is
  port (
    clk_tx   : in  std_logic;
    clk_rx   : in  std_logic;    
    data_in  : in  std_logic_vector(31 downto 0);
    ctrl     : in  std_logic_vector(7 downto 0);
    data_out : out std_logic_vector(31 downto 0)
  );
end entity TOP;

architecture RTL of TOP is

  signal data_in_int  : std_logic_vector(31 downto 0);
  signal ctrl_int     : std_logic_vector(7 downto 0);
  signal data_out_int : std_logic_vector(31 downto 0);

begin

  process (clk_tx) is
  begin
    if (clk_tx'event and clk_tx = '1') then
      ctrl_int    <= ctrl;
      data_in_int <= data_in;
      data_out    <= data_out_int;
    end if;
  end process;

  uSD_BUS: SD_BUS
    port map (
      clk_tx   => clk_tx,     
      clk_rx   => clk_rx,
      data_in  => data_in_int,
      ctrl     => ctrl_int,
      data_out => data_out_int
    );

end architecture RTL;
