library ieee;
use ieee.std_logic_1164.all;

package components is

  component IBUF is
     port (		
        data_in:  in  std_logic_vector(7 downto 0);
        data_out: out std_logic_vector(7 downto 0)
     );
  end component;

  component FF_EMPTY is
     port (
        clk:  in  std_logic;
        rst:  in  std_logic;
        data: in  std_logic_vector(7 downto 0);
        Q:    out std_logic_vector(7 downto 0)
     );
  end component;
  
  component FDR is
     port (
        clk:  in  std_logic;
        rst:  in  std_logic;
        data: in  std_logic_vector(7 downto 0);
        Q:    out std_logic_vector(7 downto 0)
     );
  end component;
  
  component FF_GENERIC is
    generic (
         ASYNC_RESET: boolean := true
     );
     port (
          clk:  in  std_logic;
          rst:  in  std_logic;
          data: in  std_logic_vector(7 downto 0);
          Q:    out std_logic_vector(7 downto 0)
     );
  end component;
  
  component CLK_GEN is
     generic (
      DIVA : integer := 2;
      DIVB : integer := 2
    );
    port (
      CLK: in std_logic;
      CLK_OUT: out std_logic;
      CLK_OUT_DIVA: out std_logic;
      CLK_OUT_DIVB: out std_logic
    );
  end component CLK_GEN;
  
  component CLK_GEN_UNCONSTRAINED is
    generic (
      DIVA : integer := 2;
      DIVB : integer := 2
    );
    port (
      CLK: in std_logic;
      CLK_OUT: out std_logic;
      CLK_OUT_DIVA: out std_logic;
      CLK_OUT_DIVB: out std_logic
    );
  end component CLK_GEN_UNCONSTRAINED;
  
  component SD_BUS is
    port (
      clk_tx   : in  std_logic;
      clk_rx   : in  std_logic;    
      data_in  : in  std_logic_vector(31 downto 0);
      ctrl     : in  std_logic_vector(7 downto 0);
      data_out : out std_logic_vector(31 downto 0)
    );
  end component SD_BUS;  
    
  component RAM is
    port (
      clka  : in  std_logic;
      addra : in  std_logic_vector(5 downto 0);
      dataa : in  std_logic_vector(7 downto 0);
      qa    : out std_logic_vector(7 downto 0);
          
      clkb  : in  std_logic;
      addrb : in  std_logic_vector(5 downto 0);
      datab : in  std_logic_vector(7 downto 0);
      qb    : out std_logic_vector(7 downto 0)
    );
  end component RAM;
  
  component NDFF_SYNCHRONIZER is
    port (
      clk:  in  std_logic;
      data: in  std_logic_vector(7 downto 0);
      sync: out std_logic_vector(7 downto 0)
    );
  end component NDFF_SYNCHRONIZER;
  
end package components;
