library ieee;
use ieee.std_logic_1164.all;

library ADC_components;
use ADC_components.components.all;

entity TOP is
	port (
		clka: in  std_logic;
		clkb: in  std_logic;
		rsta: in  std_logic;
		rstb: in  std_logic;
		data: in  std_logic_vector(7 downto 0);
		q:   out std_logic_vector(7 downto 0)
	);
end entity TOP;

architecture RTL of TOP is

  signal qtx: std_logic_vector(7 downto 0);
  signal qsync: std_logic_vector(7 downto 0);

begin

  uFFA: FDR
    port map (
      clk  => clka,
      rst  => rsta,
      data => data,
      q    => qtx
    );
	
  uNDFF_SYNCHRONIZER: NDFF_SYNCHRONIZER
    port map (
      clk  => clka,
      data => qtx,
      sync => qsync
    );

  uFFB: FDR
    port map (
      clk  => clkb,
      rst  => rstb,
      data => qsync,
      q    => q
    );

end architecture RTL;
